=== debian/changelog ===
libaria (2.7.5.2+repack-2~ubuntu13.04.1) raring-backports; urgency=low

  * No-change backport to raring (LP: #1226793)

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 14 Oct 2013 18:58:42 +0200

libaria (2.7.5.2+repack-2) unstable; urgency=low

  * libc6 dependency dropped
  * Converted to Multi-Arch

 -- Srećko Jurić-Kavelj <srecko.juric-kavelj@fer.hr>  Thu, 02 May 2013 18:41:11 +0200

libaria (2.7.5.2+repack-1) unstable; urgency=low

  * Initial release (Closes: #703357)
  * Repacked the original tarball to remove unnecesary non-source files.

 -- Srećko Jurić-Kavelj <srecko.juric-kavelj@fer.hr>  Sat, 30 Mar 2013 17:52:50 +0100
