=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export INSTALL_DIR=/usr
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

override_dh_installchangelogs:
	dh_installchangelogs Changes.txt upstream

override_dh_installdocs:
	dh_installdocs -Xfigures/ -Xoptions/ -X.dox

get-orig-source:
	wget http://robots.mobilerobots.com/ARIA/download/current/ARIA-2.7.5.2+gcc4.3.tgz
	tar xzf ARIA-2.7.5.2+gcc4.3.tgz
	mv Aria-2.7.5.2 libaria-2.7.5.2.orig
	cd libaria-2.7.5.2.orig && patch -p1 < ../patches/fix-upstream-makefile.patch
	make -C libaria-2.7.5.2.orig fullCleanAll cleanDoc cleanParams cleanSwigJava
	cd libaria-2.7.5.2.orig && patch -p1 -R < ../patches/fix-upstream-makefile.patch
	tar cjf libaria_2.7.5.2+repack.orig.tar.bz2 libaria-2.7.5.2.orig/
	rm -rf libaria-2.7.5.2.orig/ ARIA-2.7.5.2+gcc4.3.tgz
